| LPCOpen Platform v1.03 LPCOpen Platform for NXP LPC Microcontrollers

- Main Page
- Modules
- Data Structures
- Files
- Related Pages

All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
Modules | Enumerations | Functions | Variables
Device Management
USB Core - software/LPCUSBLib/Drivers/USB/USB.h

## Detailed Description

USB Device management definitions for USB device mode.

USB Device mode related definitions common to all architectures. This module contains definitions which are used when the USB controller is initialized in device mode.

## Modules
| Device Definitions and General Functions (LPC18xx)
| Device Definitions and General Functions for the LPC architecture.
| Device Management (LPC11Uxx, LPC1347)
| USB Device definitions for the LPC1347 and LPC11Uxx microcontrollers.
| Device Management (LPC17xx)
| USB Device definitions for the LPC17xx microcontrollers.

## Enumerations
enum | USB_Device_States_t { DEVICE_STATE_Unattached = 0, DEVICE_STATE_Powered = 1, DEVICE_STATE_Default = 2, DEVICE_STATE_Addressed = 3, DEVICE_STATE_Configured = 4, DEVICE_STATE_Suspended = 5 }
enum | USB_DescriptorMemorySpaces_t { MEMSPACE_FLASH = 0, MEMSPACE_EEPROM = 1, MEMSPACE_RAM = 2 }

## Functions
uint16_t | CALLBACK_USB_GetDescriptor (uint8_t corenum, const uint16_t wValue, const uint8_t wIndex, const void **const DescriptorAddress, uint8_t *MemoryAddressSpace) ATTR_WARN_UNUSED_RESULT ATTR_NON_NULL_PTR_ARG(4)
| Function to retrieve a given descriptor's size and memory location from the given descriptor type value, index and language ID. This function MUST be overridden in the user application (added with full, identical prototype and name so that the library can call it to retrieve descriptor data.

## Variables
uint8_t | USB_Device_ConfigurationNumber
bool | USB_Device_RemoteWakeupEnabled
bool | USB_Device_CurrentlySelfPowered
volatile uint8_t | USB_DeviceState []

## Enumeration Type Documentation

enum USB_DescriptorMemorySpaces_t

Enum for the possible descriptor memory spaces, for the `MemoryAddressSpace` parameter of the CALLBACK_USB_GetDescriptor() function. This can be used when none of the `USE_*_DESCRIPTORS` compile time options are used, to indicate in which memory space the descriptor is stored.

Enumerator:

  MEMSPACE_FLASH | Indicates the requested descriptor is located in FLASH memory.
  MEMSPACE_EEPROM | Indicates the requested descriptor is located in EEPROM memory.
  MEMSPACE_RAM | Indicates the requested descriptor is located in RAM memory.

Definition at line 66 of file DeviceStandardReq.h.

enum USB_Device_States_t

Enum for the various states of the USB Device state machine. Only some states are implemented in the nxpUSBlib library - other states are left to the user to implement.

For information on each possible USB device state, refer to the USB 2.0 specification.

See Also
  USB_DeviceState, which stores the current device state machine state.

Enumerator:

  DEVICE_STATE_Unattached | Internally implemented by the library. This state indicates that the device is not currently connected to a host.
  DEVICE_STATE_Powered | Internally implemented by the library. This state indicates that the device is connected to a host, but enumeration has not yet begun.
  DEVICE_STATE_Default | Internally implemented by the library. This state indicates that the device's USB bus has been reset by the host and it is now waiting for the host to begin the enumeration process.
  DEVICE_STATE_Addressed | Internally implemented by the library. This state indicates that the device has been addressed by the USB Host, but is not yet configured.
  DEVICE_STATE_Configured | May be implemented by the user project. This state indicates that the device has been enumerated by the host and is ready for USB communications to begin.
  DEVICE_STATE_Suspended | May be implemented by the user project. This state indicates that the USB bus has been suspended by the host, and the device should power down to a minimal power level until the bus is resumed.

Definition at line 72 of file Device.h.

## Function Documentation

uint16_t CALLBACK_USB_GetDescriptor | ( | uint8_t | corenum,
|  | const uint16_t | wValue,
|  | const uint8_t | wIndex,
|  | const void **const | DescriptorAddress,
|  | uint8_t * | MemoryAddressSpace
| ) |  |

Function to retrieve a given descriptor's size and memory location from the given descriptor type value, index and language ID. This function MUST be overridden in the user application (added with full, identical prototype and name so that the library can call it to retrieve descriptor data.

Parameters

  corenum | : ID Number of USB Core to be processed.
  wValue | : The type of the descriptor to retrieve in the upper byte, and the index in the lower byte (when more than one descriptor of the given type exists, such as the case of string descriptors). The type may be one of the standard types defined in the DescriptorTypes_t enum, or may be a class-specific descriptor type value.
  wIndex | : The language ID of the string to return if the `wValue` type indicates DTYPE_String, otherwise zero for standard descriptors, or as defined in a class-specific standards.
  DescriptorAddress | : Pointer to the descriptor in memory. This should be set by the routine to the address of the descriptor.
  MemoryAddressSpace | : A value from the USB_DescriptorMemorySpaces_t enum to indicate the memory space in which the descriptor is stored. This parameter does not exist when one of the `USE_*_DESCRIPTORS` compile time options is used, or on architectures which use a unified address space.

Note
  By default, the library expects all descriptors to be located in flash memory via the `PROGMEM` attribute. If descriptors should be located in RAM or EEPROM instead (to speed up access in the case of RAM, or to allow the descriptors to be changed dynamically at runtime) either the `USE_RAM_DESCRIPTORS` or the `USE_EEPROM_DESCRIPTORS` tokens may be defined in the project makefile and passed to the compiler by the -D switch.

Returns
  Size in bytes of the descriptor if it exists, zero or NO_DESCRIPTOR otherwise.

## Variable Documentation

uint8_t USB_Device_ConfigurationNumber

Indicates the currently set configuration number of the device. USB devices may have several different configurations which the host can select between; this indicates the currently selected value, or 0 if no configuration has been selected.

Note
  This variable should be treated as read-only in the user application, and never manually changed in value.

Definition at line 42 of file DeviceStandardReq.c.

bool USB_Device_CurrentlySelfPowered

Indicates if the device is currently being powered by its own power supply, rather than being powered by the host's USB supply. This flag should remain cleared if the device does not support self powered mode, as indicated in the device descriptors.

Definition at line 45 of file DeviceStandardReq.c.

bool USB_Device_RemoteWakeupEnabled

Indicates if the host is currently allowing the device to issue remote wakeup events. If this flag is cleared, the device should not issue remote wakeup events to the host.

Note
  This variable should be treated as read-only in the user application, and never manually changed in value.
  To reduce FLASH usage of the compiled applications where Remote Wakeup is not supported, this global and the underlying management code can be disabled by defining the `NO_DEVICE_REMOTE_WAKEUP` token in the project makefile and passing it to the compiler via the -D switch.

Definition at line 49 of file DeviceStandardReq.c.

volatile uint8_t USB_DeviceState[]

Indicates the current device state machine state. When in device mode, this indicates the state via one of the values of the USB_Device_States_t enum values.

This value should not be altered by the user application as it is handled automatically by the library. The only exception to this rule is if the NO_LIMITED_CONTROLLER_CONNECT token is used (see EVENT_USB_Device_Connect() and EVENT_USB_Device_Disconnect() events).

To reduce program size and speed up checks of this global on the LPC architecture, it can be placed into one of the LPC's `GPIOR` hardware registers instead of RAM by defining the `DEVICE_STATE_AS_GPIOR` token to a value between 0 and 2 in the project makefile and passing it to the compiler via the -D switch. When defined, the corresponding GPIOR register should not be used in the user application except implicitly via the library APIs.

Note
  This global is only present if the user application can be a USB device.
  This variable should be treated as read-only in the user application, and never manually changed in value except in the circumstances outlined above.

See Also
  USB_Device_States_t for a list of possible device states.